<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class GeneralService
    {
    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix=null;

    function __construct($db,$table_prefix) {$this->_db=$db;$this->table_prefix=$table_prefix; }
    
    public function checkUpdateForm($data)
    {
       $error = array();
            if (checkBlank($data['smtp_server'])) 
            {
              $error['smtp_server'] = 1;
            }
            if (!checkInt($data['smtp_port'])) 
            {
              $error['smtp_port'] = 1;
            }
            if (checkBlank($data['smtp_username'])) 
            {
              $error['smtp_username'] = 1;
            }
            if (checkBlank($data['smtp_password'])) 
            {
              $error['smtp_password'] = 1;
            }
       return $error; 
    }
                        
    public function update($data)
    {
        $smtp_server       =$data['smtp_server'];
        $smtp_port       =$data['smtp_port']; 
        $smtp_username       =$data['smtp_username']; 
        $smtp_password       =$data['smtp_password']; 
        $sql="update ".$this->table_prefix."settings set setting_value='$smtp_server' where setting_name='smtp_server'";
        $result   =$this->_db->query($sql);
        if($result==false)
        {
            return false;
        }
        $sql="update ".$this->table_prefix."settings set setting_value='$smtp_port' where setting_name='smtp_port'";
        $result   =$this->_db->query($sql);
                if($result==false)
        {
            return false;
        } 
        $sql="update ".$this->table_prefix."settings set setting_value='$smtp_username' where setting_name='smtp_username'";
        $result   =$this->_db->query($sql);
                if($result==false)
        {
            return false;
        }
        $sql="update ".$this->table_prefix."settings set setting_value='$smtp_password' where setting_name='smtp_password'";
        $result   =$this->_db->query($sql);
                if($result==false)
        {
            return false;
        }
        return true;
    }
    
    public function getValue($name)
    {
        $sql   ="select setting_value from ".$this->table_prefix."settings where setting_name='$name'";
        $result=$this->_db->query($sql);
        $value =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);   
        $this->_db->free_result($result); 
        return $value['setting_value'];
    }
    
    public function getDbSize($table_prefix)
    {
      $database_size_total=0;
      $database_size_image=0;
      $sql   ="show table status";
      $result=$this->_db->query($sql);      
      while ($row = $this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC)) 
      {
        if (eregi('^(MyISAM|ISAM|HEAP|InnoDB)$', ((isset($row['Type'])) ? $row['Type'] : $row['Engine']))) 
        {
          if ($table_prefix != "") {
            if (preg_match("/^".$table_prefix."/i", $row['Name'])) {
              $database_size_image += $row['Data_length'] + $row['Index_length'];
            }
            $database_size_total += $row['Data_length'] + $row['Index_length'];
          }
          else {
            $database_size_total += $row['Data_length'] + $row['Index_length'];
          }
        }
      }
      $this->_db->free_result($result);
      return array
            (
            "total"    => $database_size_total,
            "image" => $database_size_image
            );
    }
    
    public function listTables()
    {
       $sql   ="show tables";
       $result=$this->_db->query($sql);  
       $tables =$this->_db->fetch_all($result, 0);   
        $this->_db->free_result($result); 
        return $tables; 
    }
    
    public function listBackupFiles()
    {
        $handle = opendir(ROOT_PATH.BACKUP_PATH);
        $filelist = array();
  while ($file = readdir($handle)){
    if (is_file(ROOT_PATH.BACKUP_PATH."/".$file) && $file != "." && $file != ".." && eregi("\.sql",$file)) {
      $filelist[] = $file;
    }
  }
  closedir($handle);
  rsort($filelist);
  return $filelist;
    }
    
    public function makeBackupFiles($tables)
    {
       $crlf = (get_user_os() == "WIN") ? "\r\n" : ((get_user_os() == "MAC") ? "\r" : "\n");
       
       ob_start();
  ob_implicit_flush(0);

  echo "#----------------------------------------------------------".$crlf;
  echo "# Database Backup".$crlf;
  echo "# ".date("Y-m-d H:i").$crlf;
  echo "#----------------------------------------------------------".$crlf;
  foreach ($tables as $table) {
    echo $crlf."#".$crlf."# Structure for Table ".$table.$crlf."#".$crlf;
    get_table_def_mysql($table, $crlf);
    get_table_content_mysql($table, $crlf);
  }

  $contents = ob_get_contents();
  ob_end_clean();
  
  umask(0111);
   
      $file_name = "backup".date("YmdHi").".sql";
    $fp = fopen(ROOT_PATH.BACKUP_PATH."/".$file_name, "w");
    $ok = fwrite($fp, $contents);
    fclose($fp); 
    }
    
    public function delBackupFiles($file)
    {
         unlink(ROOT_PATH.BACKUP_PATH."/".$file);
    }
    
        public function downloadBackupFiles($file)
    {
           $size = filesize(ROOT_PATH.BACKUP_PATH."/".$file);
  header("Content-type: application/x-unknown");
  header("Content-length: $size\n");
  header("Content-Disposition: attachment; filename=$file\n");
  readfile(ROOT_PATH.BACKUP_PATH."/".$file);
  exit;
    }
    
        public function showBackupFiles($file)
    {
          ob_start();
  ob_implicit_flush(0);
    readfile(ROOT_PATH.BACKUP_PATH."/".$file);
  $contents = ob_get_contents();
  ob_end_clean();
  echo "<pre>".$contents."</pre>";
  exit;
    }
    }